#include "wiced.h"
#include "http_server.h"
#include "resources.h"

//! Webserver storage
static wiced_http_server_t httpServer;

//! Sitemap
START_OF_HTTP_PAGE_DATABASE(webPages)
    // Redirect / to /index.html
    ROOT_HTTP_PAGE_REDIRECT("/index.html"),

    // Pull /index.html from resources
    {
        "/index.html", "text/html", WICED_STATIC_URL_CONTENT,
        .url_content.static_data =
        {
            resource_apps_DIR_myWebServer_DIR_index_html,
            sizeof(resource_apps_DIR_myWebServer_DIR_index_html) - 1
        },
    },

END_OF_HTTP_PAGE_DATABASE()

//! Our IP address, netmask, and gateway
static const wiced_ip_setting_t deviceInitIpSettings =
{
    INITIALISER_IPV4_ADDRESS(.ip_address, MAKE_IPV4_ADDRESS(172,  31,   0, 1)),
    INITIALISER_IPV4_ADDRESS(.netmask,    MAKE_IPV4_ADDRESS(255, 255, 255, 0)),
    INITIALISER_IPV4_ADDRESS(.gateway,    MAKE_IPV4_ADDRESS(172,  31,   0, 1)),
};

/**
 * Application main entry point
 */
void application_start(void)
{
    // Initialize the device
    wiced_init();

    // Bring up the network interface
    wiced_network_up(WICED_AP_INTERFACE, WICED_USE_INTERNAL_DHCP_SERVER,
            &deviceInitIpSettings);

    // Start a web server
    wiced_http_server_start(&httpServer, 80, webPages, WICED_AP_INTERFACE);
}
